// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import Vue from 'vue'
import App from './App'
import router from './router'
import store from './store'
import 'element-ui/lib/theme-chalk/base.css';
import CollapseTransition from 'element-ui/lib/transitions/collapse-transition';
import ElementUI from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'
Vue.use(ElementUI, { size: "small", zIndex: 1000 })

Vue.component(CollapseTransition.name, CollapseTransition)
import './framework/style/reset.scss'

import '@/assets/style/style.scss'
import '@/assets/style/iconfont/iconfont.css'

Vue.config.productionTip = false
Vue.config.devtools = true;
/* eslint-disable no-new */
new Vue({
    el: '#app',
    router,
    store,
    components: { App },
    template: '<App/>'
})
